<html version="2.0">
<head>
<title>Status Page</title>
</head>
<body>
<center>
<h1>LDAS Control Pages</h1>
</center>
<br><br>
<a name="APIControl">
<h2>LDAS API Control</h2><p>
This page submits request to bootstrap, shutdown, remove an existent
API or add an API to LDAS system.
<ol>
	<li>Select an API from the list.</li>
	<li>Fill in the change log with your name and reason for the change.</li>
	<li>Hit SUBMIT to forward request to server.</li>
</ol>
Response: <p>
The response will be displayed in status window or an alert will popup
if there is an error in executing the request.
<p>
<a name="LDASSystemControl">
<h2>LDAS System Control</h2>
This page submits request to shutdown or restart the LDAS system at a site.
You must first shutdown an existing LDAS system before restarting a new one.

To start a new LDAS system,
<ol>
	<li>Select an LDAS site. If you need to add a new site, under File, select
		<b>Update Sites</b>, select <i><b>other</i></b> from list of sites and enter the
		relevant site information.</li>
	<li>Enter the key word.</li>
	<li>Pick a default database among the choices</li>
	<li>Hit SUBMIT to forward request to server.
</ol>
<p>Currently with openssh on ldas systems, a ldas dedicated ssh agent is needed to be running
prior to startup of LDAS to support batch mode ssh into various
machines to start up the APIs on those machines. To check for an existing agent, 
on an ldas gateway machine e.g. ldas-dev.ligo.caltech.edu, run the program
<i>/ldas/bin/ldasagent</i>; if an agent exist, it reports the existence of a ssh temp file:
e.g. <i>/tmp/ssh-vWcN7555/agent.7555</i>. If not it gives instructions on how to start an
agent. 
<p>
If there is an ssh agent or an agent has been started, set up the environment variable
as by running: 
<pre><font color='blue'>
/ldas/bin/ssh-agent-mgr --agent-file=/ldas_outgoing/managerAPI/.ldas-agent  --shell=tclsh check
# md5 1024 7b:93:91:fb:ed:9d:6f:08:c4:59:ed:b3:84:05:b5:2f /usr1/ldas/.ssh/id_rsa(RSA)
set ::env(SSH_AGENT_PID) 26008
set ::env(SSH_AUTH_SOCK) /tmp/ssh-qSJ26007/agent.26007
</font></pre>
Now use cmonClient to restart LDAS.
<p>
Response: <p>
If you request to restart a new LDAS system, eventually you will be connected
to the cntlmonAPI server when it comes up; cntlmonAPI is the last API to come up;
verify from the status display that all APIs have come up.
<p>
To shutdown a running LDAS system, select the LDAS site, connect to it,
select <b>Stop LDAS</b> and hit <SUBMIT> button.<p>

Response: <p>

A popup notifies you when cntlmonAPI is shutdown and you will be disconnected.
Verify from the status display that all APIs are down except the maanger.
LDAS has been shutdown successfully. The managerAPI is the last to shutdown.

<p>
<a name="LDASResource">
<h2>LDAS Resources</h2>
LDAS Resources are configurable global variables that can be edited to
fit the specific site needs. 
<p> cmonClient resources are automatically
displayed for editing; changes are in effect for the client session 
when the <b>APPLY CHANGES</b> button is hit and saved permanently to cmonClient.rsc file
if <b>APPLY & SAVE CHANGES</b> button is hit.  The resource file can be
re-read back into the current client session by hitting <b>RESCAN RESOURCES</b> button.
<p>
For LDAS API resources, select an API and hit <b>GET RESOURCE</b> button
to first retrieve the current values from the selected API; once the values are
displayed, they can be edited and set via the <b>APPLY CHANGES</b> button, 
and saved permanently to a local rsc file in /ldas_outgoing if 
<b>APPLY & SAVE CHANGES</b> button is hit. Global resources, if saved, will
affect all of LDAS when the system is rebooted.
<p>
Hitting the <b>Undo</b> button next to each variable restores the displayed value to the original value in
the API.
<p>
Response: <p>
The current list of resource variables and their values are displayed. If the values
have been modified and the <b>APPLY</b> buttons have been hit, the display returned
contains the new set of values.

<a name="LDASUtilities">
<h2>LDAS Utilities</h2>
This page allows restart of helper utilities; they consist of:
<ul>
The first three are started by the cntlmonAPI server and output logs in cntlmonAPI 
directory. Errors from utilities are also recorded to cntlmonAPI logs.
<p>
<li>Email alert notification - sends out email notifications if a mail.gif is recorded in
the log; done by program logscan on gateway.</li><p>

<li>Database monitor - builds the database web page and sends out email notifications 
if database file system is low etc; done by program db2utils on metaserver.</li><p>

<li><a href="#LDASCoreFiles">Core file alert notification</a> - sweeps core files to archive and sends out email notification to
interested parties; done program coreWatch running on a Linux system.</li><p>

<li><a href="#dbCreate">Create/recreate Database</a> - creates a new database; <font color='red'>Note: EXISTING ONE
IS DESTROYED.</font></li><p>

<li><a href="#dbCompare">Database compare</a> - invokes dbCompare utility to compare among the selected set
of databases column information, primary and foreign keys, indexes and
database configuration.</li><p>

<li>Purge job queue beyond entry #: - allows the jobs waiting on the queue to be all removed beyond 
the order specified, e.g. if entry is 10 and there are 20 jobs, entries 11th to 20 will be 
removed. If entry is 0, all jobs are removed from the queue.


<a name="dbCreate">
<h2>Create/Recreate LDAS database</h2>
This function creates or recreates the LDAS database. This is used to create
a brand new database or to set up a clean test database. Normally this function
is not applied to production database since data is in use or needs to be archived. 

When the command is submitted to cntlmonAPI server, it returns a work in progress
status:
<pre><font color='brown'>
box-i,06-02-2003 14:31:34> Working on it ... (createLDASdb mlei_tst /usr1/databases)
</font></pre>
When the database has been created, it returns the entire log of the process:
Here is just a section of it:
<pre><font color='brown'>
db2 response: 
   Database Connection Information
 Database server        = DB2/LINUX 7.2.0
 SQL authorization ID   = LDASDB
 Local database alias   = MLEI_TST
db2 cmd: terminate
db2 response: DB20000I  The TERMINATE command completed successfully.
db2 cmd: drop database mlei_tst
db2 response: DB20000I  The DROP DATABASE command completed successfully.
db2 cmd: create database mlei_tst on /usr2/databases alias mlei_tst
db2 response: DB20000I  The CREATE DATABASE command completed successfully.
db2 response: 
   Database Connection Information
 Database server        = DB2/LINUX 7.2.0
 SQL authorization ID   = LDASDB
 Local database alias   = MLEI_TST
db2 cmd: update database configuration for mlei_tst using logsecond 100
db2 response: DB20000I  The UPDATE DATABASE CONFIGURATION command completed successfully.
DB21026I  For most configuration parameters, all applications must disconnect 
from this database before the changes become effective.
...
db2 cmd: terminate
db2 response: DB20000I  The TERMINATE command completed successfully.
mlei_tst created on /usr2/databases
</font></pre>

<a name="dbCompare">
<h2>LDAS database comparison</h2>
This function allows databases to be compared for tables, column data ( fields,data types, default nulls ),
primary and foreign keys, indexes and database configuration parameters. <p>
When selection to compare databases is made, a dialog comes up to present the choices of
databases for a site. <p>
Select all the databases you desire and hit OK to close the dialog.
The database names are placed in the entry. <p>
Hit <b>SUBMIT</b> button to submit the request to server after providing your priviledged user name and password
at the prompt.<p>

Response: <p>
If there are no difference between two databases, the report shows nothing after
the names of the databases. <p>
<pre><font color='brown'>
----> ldas_tst vs dev_beta <-----
</font></pre>
If there are differences between two databases, the report tells what the areas
are and what is different in each.

<pre><font color='brown'>
----> cprod_1 vs ldas_tst <----- 

tables,only in cprod_1: EXTERNAL_TRIGGER
tables,only in ldas_tst: DBMDCTEST
COINC_SNGL:foreign,only in ldas_tst: H1_BURST_ID H1_BURST_CDB H2_BURST_ID H2_BURST_CDB L1_BURST_ID L1_BURST_CDB
SUMM_CSD primary keys only in cprod_1, CHANNEL1 CHANNEL2 SPECTRUM_TYPE START_TIME END_TIME
SUMM_CSD:indexes,only in cprod_1: SUMMCSD_PK
SUMM_CSD:indexes,only in ldas_tst: SUMMCSD_IND_CHAN
index SUMMCSD_PK, columns +CHANNEL1+CHANNEL2+SPECTRUM_TYPE+START_TIME+END_TIME
index SUMMCSD_IND_CHAN, columns +CHANNEL1+CHANNEL2
SUMM_SPECTRUM:indexes,only in ldas_tst: SUMMSPECT_CHAN
index SUMMSPECT_CHAN, columns +CHANNEL

----> cprod_1 vs tst_beta <----- 

tables,only in cprod_1: EXTERNAL_TRIGGER
COINC_SNGL:foreign,only in tst_beta: H1_BURST_ID H1_BURST_CDB H2_BURST_ID H2_BURST_CDB L1_BURST_ID L1_BURST_CDB
SUMM_CSD primary keys only in cprod_1, CHANNEL1 CHANNEL2 SPECTRUM_TYPE START_TIME END_TIME
SUMM_CSD:indexes,only in cprod_1: SUMMCSD_PK
SUMM_CSD:indexes,only in tst_beta: SUMMCSD_IND_CHAN
index SUMMCSD_PK, columns +CHANNEL1+CHANNEL2+SPECTRUM_TYPE+START_TIME+END_TIME
index SUMMCSD_IND_CHAN, columns +CHANNEL1+CHANNEL2
SUMM_SPECTRUM:indexes,only in tst_beta: SUMMSPECT_CHAN
index SUMMSPECT_CHAN, columns +CHANNEL
</font></pre>

<p> The following are convenience functions directed to an API by cntlmonAPI.<p>
<li>Rebuild frame disk cache - builds the frame disk cache.</li><p>
<li>Create an FTP directory - creates an ftp directory</li><p>
</ul>
<a name="UserAdmin">
<h2>LDAS User Administration</h2>
This page supports 
<ul>
<li>view user account information<p>
To get a list of registered LDAS users, hit <b>Refresh user's List</b> button.
After the list is displayed, hit a user's button ( <font color='orange'>papaya</font> color) to set the entries
on the top with the selected user's information. </li><p>
<li>add, update existing information or delete user account. 
These functions are normally disallowed on the cntlmonAPI server since there is a formal process to
administer users of LDAS. But for standalone systems or those sites not included
in the issuance of user accounts, set the cntlmonAPI resource variable
<font color='brown'>::userAdminOK</font> to 1 and reboot cntlmonAPI to allow add, update or deletion of users for the
LDAS system.</li><p>
<li>Block a user account<p>
First select a user via the user's button to display the information in the entries; if the user is not 
currently blocked, the administrator can block this user from submitting jobs to LDAS by
hitting <font color='red'>Block user</font> button. If the user has been blocked, 
blocked, hitting the <font color='green'>Unblock user</font> button will enable this user to be
active again. </li><p>
</ul>

<a name="BlockDSO">
<h2>Block DSO</h2>
This page blocks a named DSO for being used in dataPipeline commands.
<ul>
<li>view list of standard DSOs<p>
To get a list of registered LDAS users, hit <b>Refresh DSO List</b> button.
After the list is displayed, hit a DSO's button ( <font color='orange'>papaya</font> color) to set the entries
on the top with the selected DSO name. To enter one not on the list, hit <b>user_specified</b>
and enter the DSO name in entry.</li><p>
<li>Block a DSO account<p>
First select a DSO via the DSO's button to display the information in the entries; if the DSO is not 
currently blocked, the administrator can block this DSO in dataPipeline jobs to LDAS by
hitting <font color='red'>Block DSO</font> button. If the DSO has been blocked, 
blocked, hitting the <font color='green'>Unblock DSO</font> button will enable this DSO to be
active again. </li><p>
</ul>

<a name="LDASCoreFiles">

<h2>LDAS Core Files</h2>
This page displays the list of core files in the core archive. You can filter core files
based on API. If all is selected, all core files names are returned, including those
that may not belong to an API. <p>

<img src='cmonClient-corefiles.gif' width="850" height="500"><p><p>

<p>To debug a core file, click on "core file", e.g. <i>
/ldas_outgoing/savedCores/metadata.701971239.core</i> and select <b>gdb</b> or <b>ddd</b>.
<p>To delete a core file from archive, click on "core file" 
e.g. <i>/ldas_outgoing/savedCores/metadata.701971239.core</i> and select <b>delete</b>
to mark it for deletion. Hit <b>Delete Cores</b> to remove the file on LDAS.
There are buttons to select/deselect all core files.


